#-*- encoding:utf-8 -*-
require 'FailToCopyException.rb'

class DirCopy
	attr_reader :cpdata

	def initialize(d)
		@cpdata = d
	end

	def cp
		b_copy(@cpdata.from,@cpdata.to)
	end

	protected
	def isDirectoryPath?(p)
		r = File::ftype(p)
		return true if r == "directory"
		return false if r != "directory"
	end

	protected
	def b_copy(from,to)
		raise(FailToCopyException,"#{from} is not directory.") unless isDirectoryPath?(from)
		unless File::exist?(to) then
			begin
				Dir.mkdir(to)
			rescue Errno::EACCES
				STDERR.puts "acopy cannnot make directory :: #{to}"
				return false
			rescue
				STDERR.puts  "error. fail to make directory :: #{to}"
				return false
			end
		end

		(Dir.new(from)).each do |f|
			if f == "." or f == ".." then
				next
			end
			if isDirectoryPath?(from + File::SEPARATOR + f)
				return false unless b_copy(from + File::SEPARATOR + f,to + File::SEPARATOR + f)
			else
				return false unless cpfile(from + File::SEPARATOR + f,to + File::SEPARATOR + f)
			end
		end
		return true
	end

	protected
	def cpfile(from,to)
		if File.exists?(to) and @cpdata.mode != :overwrite then
			return true
		end

		begin
			src = open(from)
		rescue Errno::ENOENT 
			puts "[ERROR] #{from} is no such file or directory."
			return false
		end
		puts "#{to}"
		dest = open(to,'w')

		dest.write(src.read())
		dest.close
		src.close
		return true
	end
end
